import { asyncDelay, onHomeworkFinish } from "../script/util";
import { MyCocosSceneComponent } from "../script/MyCocosSceneComponent";
import { fromBase64 } from "js-base64";
import timuPrefab from "../script/timuPrefab";

const { ccclass, property } = cc._decorator;

export enum PAGE{
    START = 0,
    GAMEING = 1,
    GAMEOVER = 2
}


export enum SOUND_NAME{
    DANGAI_ENTER = "dan_enter",
}


@ccclass
export default class SceneComponent extends MyCocosSceneComponent {
    private mengban:cc.Node;
    private btn_start:cc.Node;
    private lab_title:cc.Node;

    private curPage = PAGE.START;
    private resName = "Canvas/mine/";
    private megnbanTweenTime = 0.5;//秒
    private timu_arr:Array<string> = [];

    private right_node:cc.Node;
    private timu_rightshadow:cc.Node;
    private danblue:cc.Node;
    private danred:cc.Node;
    private timu_right:cc.Node;

    private rightShadows:Array<cc.Node> = [];
    private rightDanBlues:Array<cc.Node> = [];
    private rightDanReds:Array<cc.Node> = [];
    private rightTimuOn:Array<cc.Node> = [];

    private curIndex = -1;


    private timu_node:cc.Node;
    private timu_prefab:cc.Node;

    addPreloadImage() {
        // TODO 根据自己的配置预加载图片资源
        // this._imageResList.push({ url: this.data.pic_url });
        // this._imageResList.push({ url: this.data.pic_url_2 });
    }

    addPreloadAudio() {
        // TODO 根据自己的配置预加载音频资源
        // this._audioResList.push({ url: this.data.audio_url });
    }

    addPreloadAnima() {

    }

    onLoadEnd() {
        // TODO 加载完成后的逻辑写在这里, 下面的代码仅供参考
        this.initData();
        this.initView();
        this.initListener();
    }

    // _cantouch = null;
    initData() {
        // 所有全局变量 默认都是null 
        // this._cantouch = true;
        this.timu_arr = this.data.timu_arr;

    }

    initView() {
        this.initUI();
        this.initShow();
        this.onResize();
        this.swithPage();
    }

    initListener() {
        this.btn_start.on('click', this.startClick,this);
    }

    startClick(event:cc.Event){
        this.curPage = PAGE.GAMEING;
        // this.playLocalAudio('btn');
        this.log("click");
        this.swithPage();
    }

    test(){
        //移动端才有的方法调试的需要真机，浏览器没有
        window["courseware"].startTest("aa bb cc");

        window["courseware"].stopTest((res) => {
            console.log(res);
        });
    }

    initUI(){
        const mine = cc.find('Canvas/mine');
        this.initCom(mine,this);

        cc.view.setResizeCallback(() => {this.onResize();});
    }
    
    initCom(parent:cc.Node,thisObj:any){
        for(var i = 0;i < parent.children.length;i++){
            if(parent.children[i].childrenCount == 0 || parent.children[i].active == false){
                let name = parent.children[i].name;
                thisObj[name] = parent.children[i];
            }
            else{
                this.initCom(parent.children[i],thisObj);
            }
        }
    }

    initShow(){
        this.lab_title.getComponent(cc.Label).string = this.data.title_text;

        for(var i = 0;i < this.timu_arr.length;i++){
            let node = cc.instantiate(this.timu_rightshadow);
            this.right_node.addChild(node);
            node.x = -i * 50;
            node.y = 0;
            node.active = false;
            this.log("node:" + node.x);
            this.rightShadows.push(node);


            let node2 = cc.instantiate(this.danblue);
            this.right_node.addChild(node2);
            node2.x = node.x;
            node2.y = node.y
            node2.active = false;
            this.rightDanBlues.push(node2);

            let node3 = cc.instantiate(this.danred);
            this.right_node.addChild(node3);
            node3.x = node.x;
            node3.y = node.y
            node3.active = false;
            this.rightDanReds.push(node3);

            let node4 = cc.instantiate(this.timu_right);
            this.right_node.addChild(node4);
            node4.x = node.x;
            node4.y = node.y
            node4.active = false;
            this.rightTimuOn.push(node4);

        }

        this.rightShadows.reverse();
        this.rightDanBlues.reverse();
        this.rightDanReds.reverse();
        this.rightTimuOn.reverse();
    }

    onResize(){
        this.initSize();

        const mine = cc.find('Canvas/mine');
        for(var i = 0;i < mine.children.length;i++){
            let node = mine.children[i];
            if(node.name == "bg" || node.name == "mengban"){
                node.scale = this._mapScaleMax;
            }
            else{
                node.scale = this._mapScaleMin;
            }
        }
        // else if(node.name == "lab_title"){//lab_title在子节点，不用管
        // }
    }

    showMengBan(tween:boolean = true){
        if(tween == false){
            this.mengban.active = true;
            this.mengban.opacity = 255;
        }
        else{
            this.mengban.active = false;
            this.mengban.opacity = 0;
            cc.tween(this.mengban)
                .to(this.megnbanTweenTime, { opacity: 255 }, { easing: 'cubicInOut' })
                .call(() => {
                    this.mengban.active = true;
                    this.mengban.opacity = 255;
                })
                .start();
        }

    }
    hideMengBan(tween:boolean = true){
        if(tween == false){
            this.mengban.active = false;
            this.mengban.opacity = 0;
        }
        else{
            this.mengban.active = true;
            this.mengban.opacity = 255;
            cc.tween(this.mengban)
                .to(this.megnbanTweenTime, { opacity: 0 }, { easing: 'cubicInOut' })
                .call(() => {
                    this.mengban.active = false;
                    this.mengban.opacity = 0;
                })
                .start();
        }

    }

    swithPage(){
        if(this.curPage == PAGE.START){
            this.showMengBan(false);
            this.btn_start.active = true;
        }
        else if(this.curPage == PAGE.GAMEING){
            this.hideMengBan();
            this.btn_start.active = false;
            this.next();
        }
    }

    
    removeListener() {
        this.btn_start.off('click', this.startClick,this);
    }

    ondestroy(){
        this.removeListener();
        this.timu_arr.length = 0;

    }


    //最终展示，展示当前
    next(){
        this.curIndex = this.curIndex + 1;

        for(var i = 0;i < this.rightShadows.length;i++){
            this.rightShadows[i].active = true;

            if(i < this.curIndex){//完成了的
                this.rightDanBlues[i].active = false;

                let right = false;
                if(right){
                    this.rightTimuOn[i].active = true;
                    this.rightDanReds[i].active = false;
                }
                else{
                    this.rightTimuOn[i].active = false;
                    this.rightDanReds[i].active = true;
                }
            }
            else if(i == this.curIndex){//正在做
                this.rightDanBlues[i].active = true;
                this.rightTimuOn[i].active = false;
                this.rightDanReds[i].active = false;
            }
            else if(i > this.curIndex){//未作
                this.rightDanBlues[i].active = false;
                this.rightTimuOn[i].active = false;
                this.rightDanReds[i].active = false;
            }
        }


        this.addTimu();
        

    }

    addTimu(){
        let node = cc.instantiate(this.timu_prefab);
        this.timu_node.addChild(node);
        node.x = 0;
        node.y = 0;
        node.active = true;
        let com:timuPrefab = node.getComponent("timuPrefab");
        com.initUI();
        com.setString(this.timu_arr[this.curIndex],this.data.timu_right_arr[this.curIndex],this.data.timu_wrong_arr[this.curIndex]);
        com.moveLeft();
        this.playLocalAudio(SOUND_NAME.DANGAI_ENTER);
        this.playTiMuEffect();
    }

    addLaZhu(){

    }



    //播放题干音效
    playTiMuEffect(){

    }

    ////////////////////////
    pic1 = null;
    pic2 = null;
    initPic() {
        // const canvas = cc.find('Canvas');
        // const maxW = canvas.width * 0.7;

        // this.getSprNodeByUrl(this.data.pic_url, (sprNode) => {
        //     const picNode1 = sprNode;
        //     picNode1.scale = maxW / picNode1.width;
        //     picNode1.baseX = picNode1.x;
        //     canvas.addChild(picNode1);
        //     this.pic1 = picNode1;

        //     const labelNode = new cc.Node();
        //     labelNode.color = cc.Color.YELLOW;
        //     const label = labelNode.addComponent(cc.Label);
        //     label.string = this.data.text;
        //     label.fontSize = 60;
        //     label.lineHeight = 60;
        //     label.font = cc.find('Canvas/res/font/BRLNSDB').getComponent('cc.Label').font;
        //     picNode1.addChild(labelNode);
        // });

        // this.getSprNodeByUrl(this.data.pic_url_2, (sprNode) => {
        //     const picNode2 = sprNode;
        //     picNode2.scale = maxW / picNode2.width;
        //     canvas.addChild(picNode2);
        //     picNode2.x = canvas.width;
        //     picNode2.baseX = picNode2.x;
        //     this.pic2 = picNode2;

        //     const labelNode = new cc.Node();
        //     const label = labelNode.addComponent(cc.RichText);
        //     const size = 60
        //     label.font = cc.find('Canvas/res/font/BRLNSDB').getComponent(cc.Label).font;
        //     label.string = `<outline color=#751e00 width=4><size=${size}><color=#ffffff>${this.data.text}</color></size></outline>`
        //     label.lineHeight = size;
        //     picNode2.addChild(labelNode);
        // });

    }

    initIcon() {
        // const iconNode = this.getSprNode('icon');
        // iconNode.zIndex = 5;
        // iconNode.anchorX = 1;
        // iconNode.anchorY = 1;
        // iconNode.parent = cc.find('Canvas');
        // iconNode.x = iconNode.parent.width / 2 - 10;
        // iconNode.y = iconNode.parent.height / 2 - 10;

        // iconNode.on(cc.Node.EventType.TOUCH_START, () => {
        //     this.playAudioByUrl(this.data.audio_url);
        // })
    }

    // curPage = null;
    initBtn() {

        // this.curPage = 0;
        // const bottomPart = cc.find('Canvas/bottomPart');
        // bottomPart.zIndex = 5; // 提高层级

        // bottomPart.x = bottomPart.parent.width / 2;
        // bottomPart.y = -bottomPart.parent.height / 2;

        // const leftBtnNode = bottomPart.getChildByName('btn_left');
        // //节点中添加了button组件 则可以添加click事件监听
        // leftBtnNode.on('click', () => {
        //     if (!this._cantouch) {
        //         return;
        //     }
        //     if (this.curPage == 0) {
        //         return;
        //     }
        //     this.curPage = 0
        //     this.leftMove();

        //     this.playLocalAudio('btn');
        // })

        // const rightBtnNode = bottomPart.getChildByName('btn_right');
        // //节点中添加了button组件 则可以添加click事件监听
        // rightBtnNode.on('click', () => {
        //     if (!this._cantouch) {
        //         return;
        //     }
        //     if (this.curPage == 1) {
        //         return;
        //     }

        //     this.curPage = 1
        //     this.rightMove();

        //     // 游戏结束时需要调用这个方法通知系统作业完成
        //     onHomeworkFinish();

        //     this.playLocalAudio('btn');
        // })
    }

    leftMove() {
        // this._cantouch = false;
        // const len = this.pic1.parent.width;
        // cc.tween(this.pic1)
        //     .to(1, { x: this.pic1.baseX }, { easing: 'cubicInOut' })
        //     .start();

        // cc.tween(this.pic2)
        //     .to(1, { x: this.pic2.baseX }, { easing: 'cubicInOut' })
        //     .call(() => {
        //         this._cantouch = true;
        //     })
        //     .start();
    }

    rightMove() {
        // this._cantouch = false;
        // const len = this.pic1.parent.width;
        // cc.tween(this.pic1)
        //     .to(1, { x: this.pic1.baseX - len }, { easing: 'cubicInOut' })
        //     .start();

        // cc.tween(this.pic2)
        //     .to(1, { x: this.pic2.baseX - len }, { easing: 'cubicInOut' })
        //     .call(() => {
        //         this._cantouch = true;
        //     })
        //     .start();
    }
    // update (dt) {},


    playLocalAudio(audioName) {
        const audio = cc.find(`Canvas/res/audio/${audioName}`).getComponent(cc.AudioSource);
        return new Promise((resolve, reject) => {
            const id = cc.audioEngine.playEffect(audio.clip, false);
            cc.audioEngine.setFinishCallback(id, () => {
                resolve(id);
            });
        })
    }
}
